#    
#	  This file is part of MD5 Decrypter
#
#	  MD5 Decrypter is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http:#www.gnu.org/licenses/>.

#	  Author: Matheus Bratfisch [matheusbrat AT gmail dot com]

import socket
import Listener
import Searcher
import ResponseAnalyzer
import sys

class Slave:
	MD5String = None
	finish = False
	responseAnalyzer = ResponseAnalyzer.ResponseAnalyzer()
	begin = None
	end = None

	def __init__(self, ip, port):
		self.connection = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		self.connection.connect((ip, port))
		self.ip = ip
		self.port = port

#		dat = ""
#		Keep = True
#		while (Keep):
#			char = self.connection.recv(1)
#			if char == "\n": 
#				Keep = False
#			else: 
#				dat=dat+char

#		self.responseAnalyzer.getAnswer(self, dat)

		self.listener = Listener.Listener(self)
		self.listener.start()

		self.searcher = Searcher.Searcher(self)
		self.searcher.start()		

		self.searcher.join();
		self.searcher.join();

	
	def send(self, message): 
		print "Sending ", message
		self.connection.send(message + "\n")

	def setMD5Str(self, md5):
		self.MD5String = md5


	def getMD5Str(self):
		return self.MD5String

	def setFinish(self, f):
		self.finish = f
	
	def getFinish(self):
		return self.finish

if __name__ == '__main__':
    print len(sys.argv)
    if (len(sys.argv) == 3):
	    Slave(sys.argv[1], int(sys.argv[2]))
    else:
	print "Slaves takes exactly two arguments. The ip address and the port."
